##SOLUES DOS EXERCCIOS DA UNIDADE 3 : FUNOES NO R

################################################################################
##2.1. Estimador de Pollard

## Estimativa de densidade (em individuos por metro quadrado)
np <- (4*(4*30-1))/(pi*2531.794)

## Varincia da estimativa
np/(4*30-2)
################################################################################

################################################################################
##2.2. rea transversal de uma rvore

## Uma rvore com DAP= 13,5 cm
pi*(13.5/2)^2

## rvore com DAPs de 7cm, 9cm e 12cm
pi*(7/2)^2 + pi*(9/2)^2 + pi*(12/2)^2
################################################################################


################################################################################
##2.3. rea transversal de uma rvore (Revisitado)
2*sqrt( (pi*(7/2)^2 + pi*(9/2)^2 + pi*(12/2)^2)/pi )
##ou, simplificando:
2*sqrt( (7/2)^2 + (9/2)^2 + (12/2)^2 )
################################################################################


################################################################################
##2.4. Clculo da Biomassa de rvores do Cerrado
##Primeira estimativa:
est.1 <- exp(-1.7953)*15^2.2974
##Segunda estimativa
log.est.2 <- -2.6464+1.9960*log(15)+0.7558*log(12)
## Comparacao
est.1
exp(log.est.2)
################################################################################


################################################################################
##2.7. Palmeira com Muitos Fustes I
dap <- c(5, 6, 7, 5, 10, 11, 6, 8, 9 ,7)
dap
dap.index <- 1:length(dap)
names(dap) <- dap.index
dap

################################################################################



################################################################################
##2.8.  Palmeira com Muitos Fustes II
## 1 - Calcule a rea transversal de cada fuste
##por etapas (usando o objeto dap do exerccio anterior, e vrios objetos intermedirios):
dap.r <- dap/2
dap.r2 <- dap.r^2
dap.area <- dap.r2*pi
dap.area
##De uma vez s:
(dap/2)^2 * pi

##2 -Calcule a mdia das reas, sem usar a funo mean
dap.area.media <- sum(dap.area)/length(dap.area)
dap.area.media
##conferindo:
mean(dap.area)

##3 -Calcule a variancia amostral das areas, sem usar a funo var
dap.area.var <- sum((dap.area-dap.area.media)^2)/(length(dap.area)-1)
dap.area.var
##conferindo:
var(dap.area)
################################################################################



################################################################################
##2.9. Bits e Bytes
## Primeiros 10 valores
2^(1:10)
################################################################################



################################################################################
##2.10. Conta de luz
leituras <- c(9839, 10149, 10486, 10746, 11264, 11684, 12082, 13004, 13350, 13717, 14052)
##1. Calculo do consumo
consumo <- diff(leituras)
consumo
## 2. Consumos mximos e mnimos
##Com dois comandos
max(consumo)
min(consumo)
##ou simplesmente:
range(consumo)
##3. Mdia, mediana e varincia do consumo
mean(consumo)
median(consumo)
var(consumo)
################################################################################


################################################################################
##2.13 Amplitude da Normal
amostra.100 <- rnorm(100)
amostra.1000 <- rnorm(1000)
amostra.10000 <- rnorm(10000)
diff(range(amostra.100))
diff(range(amostra.1000))
diff(range(amostra.10000))
################################################################################


################################################################################
##2.14. Intervalo Normal I
## Limite inferior: quantil da normal padronizada que corresponde a 25% da rea
qnorm(p=0.25)
## Limite superior: quantil da normal padronizada que corresponde a 75% da rea
qnorm(p=0.75) ## Clculo desnecessrio, j que a normal  simtrica na mdia.

##Um Grfico para deixar mais claro
curve(dnorm(x),xlab="Quantil", ylab="Densidade probabilstica") ##Consulte a ajuda da funo "curve"
abline(v=qnorm(p=0.25), col="red")
abline(v=qnorm(p=0.75), col="red")
################################################################################


################################################################################
## 2.15. Intervalo Normal II
pnorm(q=1.96) - pnorm(q=-1.96) 
################################################################################

################################################################################
##2.16. Teste t
##Duas solues:
2*pt(q=-2.2,df=19)
2*pt(q=2.2,df=19, lower.tail=F)
##E se o valor fosse 1.9?
2*pt(q=-1.9,df=19)
################################################################################


################################################################################
## 2.17. Teste F
pf(q=2.2, df1=19, df2=24, lower.tail=F)
pf(q=2.5, df1=19, df2=24, lower.tail=F)
################################################################################



################################################################################
## 2.18. Padro Espacial I
x <- runif(n=1000,min=0,max=100)
y <- runif(1000,0,100)
plot(x,y)
################################################################################



################################################################################
##2.19. Padro Espacial II
xp <- runif(10,0,100)
yp <- runif(10,0,100)
xf <- rnorm(1000,sd=2)
yf <- rnorm(1000,sd=2)
plot(xp+xf,yp+yf)
##Para ficar mais claro:
plot(xp+xf,yp+yf,cex=0.2)
points(xp,yp,col="red", pch=19)
################################################################################



################################################################################
##2.20. Grfico Quantil-quantil
##Distribuio Normal
p <- seq(0, 1, length=1000)
xn <- sort(rnorm(1000,mean=1,sd=2))
plot(qnorm(p, mean=1, sd=2),xn)
## Distribuio exponencial
xe <- sort(rexp(1000))
plot(qnorm(p, mean=1, sd=2),xe)
## Para ajudar na resposta, veja os histogramas dos dois vetores de nmeros sorteados
par(mfrow=c(1,2))
hist(xn)
hist(xe)
par(mfrow=c(1,1))
################################################################################
